/**
	$Id:CompactButtonRendererFactory.java 4187 2008-03-20 11:15:25Z nicklas $

	Copyright (C) Authors contributing to this file.

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.toolbar;

import net.sf.basedb.clients.web.extensions.AbstractJspRendererFactory;
import net.sf.basedb.clients.web.extensions.JspContext;
import net.sf.basedb.util.extensions.InvokationContext;

/**
	Factory that create {@link CompactButtonRenderer} objects
	for rendering {@link ButtonAction}:s.

	@author nicklas
	@version 2.7
	@base.modified $Date:2008-03-20 12:15:25 +0100 (Thu, 20 Mar 2008) $
*/
public class CompactButtonRendererFactory
	extends AbstractJspRendererFactory<ButtonAction>
{

	private String buttonTag= "a";
	
	public CompactButtonRendererFactory()
	{}
	
	@Override
	public CompactButtonRenderer getRenderer(InvokationContext<? extends ButtonAction> context)
	{
		CompactButtonRenderer renderer = new CompactButtonRenderer((JspContext)context.getClientContext());
		renderer.setButtonTag(getButtonTag());
		return renderer;
	}

	/**
		Set the HTML tag to use for the "button". The default is 'a'.
		@since 3.16
	*/
	public void setButtonTag(String tag)
	{
		this.buttonTag = tag;
	}
	
	/**
		Get the HTML tag to use for the "button". The default is 'a'.
		@since 3.16
	*/
	public String getButtonTag()
	{
		return buttonTag;
	}
	
}
