package net.sf.basedb.util.extensions;

/**
	Abstract class that provides a default implementation
	of the deprecated {@link #render(Action)} method. The
	implementation call the new {@link #render(Action, Extension)}
	method with a null parameter for the extension. This class
	can be used by renderers that want an easy way to migrate to the
	new API and that don't need the extension instace.
	@since 3.19.8
*/
public abstract class AbstractRenderer <A extends Action>
	implements Renderer<A>
{

	@Override
	@Deprecated
	public void render(A action) 
	{
		render(action, null);
	}
	
}
