/**
	$Id: ExtensionPointFilter.java 5598 2011-03-30 09:44:57Z nicklas $

	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.util.extensions.xml;

import org.jdom2.Element;

import net.sf.basedb.util.filter.Filter;

/**
	Filter implementation that only matches tags for plug-in definitions.
	This filter is useful if the parser is not interested in extensions.
	
	@author Nicklas
	@since 3.0
	@base.modified $Date: 2011-03-30 11:44:57 +0200 (on, 30 mar 2011) $
*/
public class PluginDefinitionFilter
	implements Filter<Element>
{

	
	/**
		Create a new filter.
	*/
	public PluginDefinitionFilter()
	{}
	
	/*
		From the Filter interface
		--------------------------
	*/
	@Override
	public boolean evaluate(Element tag)
	{
		return "plugin-definition".equals(tag.getName());
	}
	// --------------------------
}
