/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
'use strict';

var Preset = function()
{
	var preset = {};
	
	/**
		Initialize the page.
	*/
	preset.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', preset.save);
	}
	
	/**
		Check that the form is correctly filled in.
		A name must be entered. If another preset with the same
		name exists the user must confirm if it should be replaced.
	 */
	preset.validateForm = function()
	{
		var frm = document.forms['preset'];
		if (Strings.trim(frm.name.value) == '')
		{
			Forms.showNotification(frm.name, 'Please enter a name');
			return false;
		}
		var presets = window.opener.document.forms['columns'].presets;
		for (var i = 0; i < presets.length; i++) // >
		{
			if (presets[i].text == frm.name.value) 
			{
				return confirm('Another preset with the same name already exists. Do want to replace it?');
			}
		}
		return true;
	}
	
	/**
		Save the settings.
	*/
	preset.save = function()
	{
		var frm = document.forms['preset'];
		if (preset.validateForm())
		{
			var presets = window.opener.document.forms['columns'].presets;
			var name = frm.name.value;
			var addIndex = presets.length;
			for (var i = 0; i < presets.length; i++) // >
			{
				if (presets[i].text == name) 
				{
					addIndex = i;
					i = presets.length;
				}
			}
			presets[addIndex] = new Option(name, frm.columns.value);
			if (frm.stickyColumn)
			{
				Data.set(presets[addIndex], 'sticky-column', frm.stickyColumn.value);
			}
			presets.selectedIndex = addIndex;
			frm.submit();
		}
	}
	
	return preset;
}();

Doc.onLoad(Preset.initPage);