<%-- $Id: list_files.jsp 8180 2023-12-06 12:05:57Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemContext.SortDirection"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Quantity"
	import="net.sf.basedb.core.Unit"
	import="net.sf.basedb.core.query.Restriction"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.units.UnitUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerUtil"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerContext"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Iterator"
	import="java.util.Map"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FILE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final String subcontext = Values.getString(request.getParameter("subcontext"), "");
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subcontext, null, null);

final int directoryId = Values.getInt(request.getParameter("directory_id"), SystemItems.getId(Directory.ROOT));
final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = null; //mode.generateTitle("file", "files");
final boolean isSearch = "search".equals(subcontext);
final boolean hasFilter = cc.getNumPropertyFilters() > 0;
final DbControl dc = sc.newDbControl(":List "+itemType);
ItemResultIterator<File> files = null;
ItemResultIterator<Directory> directories = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();
try
{
	final Directory current = isSearch ? null : Directory.getById(dc, directoryId);
	final String currentPath = current == null ? null : HTML.encodeTags(current.getPath().toString());
	final boolean createFilePermission = isSearch ? false : sc.hasPermission(Permission.CREATE, itemType) && current.hasPermission(Permission.USE);
	final boolean createDirectoryPermission = isSearch ? false : sc.hasPermission(Permission.CREATE, Item.DIRECTORY) && current.hasPermission(Permission.USE);

	Unit bytes = UnitUtil.getUnit(dc, Quantity.STORAGE_SIZE, "B");
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}

	// Get all file types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);

	// Create directory query
	final ItemQuery<Directory> directoryQuery = Directory.getQuery();
	directoryQuery.setIncludes(cc.getInclude());
	if (!isSearch) 
	{
		// Limit to current directory; no paging
		directoryQuery.restrict(Restrictions.eq(Hql.property("parent"), Hql.entity(current)));
		directoryQuery.setFirstResult(0);
		directoryQuery.setMaxResults(-1);
		directoryQuery.setReturnTotalCount(false);
	}
	else
	{
		// Never match the root directory; setup paging
		directoryQuery.restrict(Restrictions.neq(Hql.property("parent"), null));
		directoryQuery.setFirstResult(cc.getPage() * cc.getRowsPerPage());
		directoryQuery.setMaxResults(cc.getRowsPerPage());
		directoryQuery.setReturnTotalCount(false);
	}
	boolean hasDirFilter = false;
	List<Restriction> allDirRestrictions = new ArrayList<Restriction>();
	for (int filterRow = 0; filterRow < cc.getFilterRows(); filterRow++)
	{
		List<Restriction> rowFilter = new ArrayList<Restriction>();
		// Add 'name', 'description' and other common filters to directory query
		PropertyFilter filter = cc.getPropertyFilter("name", filterRow);
		if (filter != null) 
		{
			rowFilter.add(filter.getRestriction(dc, directoryQuery));
		}
		filter = cc.getPropertyFilter("description", filterRow);
		if (filter != null) 
		{
			rowFilter.add(filter.getRestriction(dc, directoryQuery));
		}
		filter = cc.getPropertyFilter("compressed", filterRow);
		if (filter != null)
		{
			rowFilter.add(Restrictions.eq(Hql.property("autoCompress"), Expressions.parameter("ac"+filterRow)));
			directoryQuery.setParameter("ac"+filterRow, filter.getValueAsObject(), Type.BOOLEAN);
		}
		filter = cc.getPropertyFilter("!sharedTo.name", filterRow);
		if (filter != null) 
		{
			rowFilter.add(filter.getRestriction(dc, directoryQuery));
		}
		filter = cc.getPropertyFilter("directory.name", filterRow);
		if (filter != null)
		{
			filter = new PropertyFilter("parent.name", filter.getOperator(), filter.getValue(), filter.getValueType());
			rowFilter.add(filter.getRestriction(dc, directoryQuery));
		}
		filter = cc.getPropertyFilter("owner.name", filterRow);
		if (filter != null)
		{
			rowFilter.add(filter.getRestriction(dc, directoryQuery));
		}
		if (rowFilter.size() > 0)
		{
			allDirRestrictions.add(Restrictions.nullSafeAnd(rowFilter));
		}
	}
	if (allDirRestrictions.size() > 0)
	{
		directoryQuery.restrict(Restrictions.nullSafeOr(allDirRestrictions));
		hasDirFilter = true;
	}
	if (cc.getItemPermission() != null) directoryQuery.setItemPermission(cc.getItemPermission());
	
	// Add sort order to directory query
	String sortProperties = cc.getSortProperty();
	boolean sorted = false;
	if (sortProperties != null)
	{
		String[] tmp = sortProperties.split(",");
		SortDirection sortDirection = cc.getSortDirection();
		for (String sort : tmp)
		{
			if ("name".equals(sort) || "description".equals(sort) || "owner.name".equals(sort))
			{
				directoryQuery.order(sortDirection.sortBy(Hql.property(sort)));
				sorted = true;
			}
			else if ("directory.name".equals(sort))
			{
				directoryQuery.order(sortDirection.sortBy(Hql.property("parent.name")));
				sorted = true;
			}
		}
	}
	if (!sorted)
	{
		directoryQuery.order(Orders.asc(Hql.property("name")));
	}
	
	int numDirectories = isSearch && hasDirFilter ? (int)directoryQuery.count(dc) : 0;
	int maxFiles = cc.getRowsPerPage();
	
	// Get all files in current directory
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, current);
	final ItemQuery<File> fileQuery = Base.getConfiguredQuery(dc, cc, jspContext, true, File.getQuery(), mode);
	if (!isSearch) 
	{
		fileQuery.restrict(Restrictions.eq(Hql.property("directory"), Hql.entity(current)));
		fileQuery.setFirstResult(0);
		fileQuery.setMaxResults(-1);
		fileQuery.setReturnTotalCount(false);
	}
	else
	{
		int firstFile = cc.getPage() * cc.getRowsPerPage() - numDirectories;
		if (firstFile < 0) 
		{
			maxFiles += firstFile;
			firstFile = 0;
			if (maxFiles < 0) maxFiles = 0;
		}
		fileQuery.setFirstResult(firstFile);
		fileQuery.setMaxResults(maxFiles);
		fileQuery.setReturnTotalCount(false);
	}

	int numFiles = isSearch && hasFilter ? (int)fileQuery.count(dc) : 0;
	try
	{
		files = !isSearch || hasFilter && maxFiles > 0 ? fileQuery.iterate(dc) : null;
		directories = !isSearch || hasDirFilter ? directoryQuery.iterate(dc) : null;
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	
	int numListed = 0;
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker<ListColumnAction<File,?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	FileViewerContext fileContext = FileViewerContext.file();
	FileViewerUtil fileViewer = FileViewerUtil.getOrCreate(jspContext, fileContext);
	fileViewer.setPrefixAndSuffix("", "");
	%>
	<base:page title="<%=title==null ? "Files" : title%>" type="iframe" id="list-page">
	<base:head scripts="table.js,menu.js,dragdrop.js,~files.js" styles="table.css,toolbar.css,menu.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.drop-upload > th, .drop-upload > td
		{
			border-top: 1px solid black !important;
			border-bottom: 1px solid black !important;
			background-color: white !important;
		}
		#uploadTooltip
		{
			position: absolute;
			background-color: white;
			padding: 0.25em;
			z-index: 999;
			max-width: 30em;
			border-radius: 5px;
			box-shadow: 0 0 6px;
		}
		</style>
	</base:head>
	
	<base:body>
	<m:menu 
		id="moveFiles"
		style="display: none;">
		<m:menuitem 
			id="mnuMoveToDirectory"
			title="To another directory&hellip;" 
			tooltip="Move the selected files and directories to another directory"
		/>
		<m:menuseparator />
		<m:menuitem 
			id="mnuMoveOffline"
			data-location="OFFLINE"
			title="Offline&hellip;" 
			tooltip="Remove the selected files from the server (immedately)"
		/>
		
	</m:menu>
	<div id="main" class="absolutefull topborder auto-init" data-auto-init="drag-support" data-upload-permission="<%=createFilePermission?1:0%>">
		<div id="page-data" class="datacontainer"
			data-is-search="<%=isSearch ? 1 : 0 %>"
			data-files-found="<%=numFiles %>"
			data-directories-found="<%=numDirectories %>"
			data-current-directory-id="<%=current == null ? 0 : current.getId() %>"
			data-current-path="<%=currentPath == null ? "" : currentPath %>"
		></div>
	
		<div id="uploadTooltip" class="messagecontainer" style="display: none;"></div>
	
		<tbl:table 
			id="files"
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subcontext%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			stickyheaders="<%=cc.getSetting("columns.sticky", "name")%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="subcontext" 
				value="<%=subcontext%>"
				skip="<%=subcontext == null%>" 
			/>
			<tbl:hidden 
				name="directory_id" 
				value="<%=Integer.toString(directoryId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				clazz="uniquecol"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef
				id="path"
				title="Path"
				property="directory.name"
				exportproperty="path"
				tooltip="Only the immediate parent directory can be searched or sorted"
				datatype="string"
				sortable="true"
				filterable="true"
				exportable="true"
				show="<%=isSearch ? "always" : "never" %>"
			/>
			<tbl:columndef 
				id="url"
				property="url"
				datatype="string"
				title="URL"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="fileServer"
				property="fileServer.name"
				datatype="string"
				title="File server"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="size"
				property="size"
				datatype="long"
				title="Size"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=bytes%>"
			/>
			<tbl:columndef 
				id="compressedSize"
				property="compressedSize"
				datatype="long"
				title="Compressed size"
				sortable="true" 
				filterable="true"
				exportable="true"
				unit="<%=bytes%>"
			/>
			<tbl:columndef 
				id="compressed"
				property="compressed"
				datatype="boolean"
				title="Is compressed"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="writeProtected"
				property="writeProtected"
				datatype="boolean"
				title="Write protected"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="itemSubtype"
				property="itemSubtype"
				sortproperty="itemSubtype.name"
				exportproperty="itemSubtype.name:string"
				datatype="int"
				enumeration="<%=Enumeration.fromItems(subtypesQuery.list(dc), "-none-")%>"
				title="Type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="mimeType"
				property="mimeType"
				datatype="string"
				title="Mime type"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="characterSet"
				property="characterSet"
				datatype="string"
				title="Character set"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<%
			Enumeration<String, String> locations = new Enumeration<String, String>();
			for (Location l : Location.values())
			{
				locations.add(Integer.toString(l.getValue()), l.toString());
			}
			%>
			<tbl:columndef 
				id="location"
				property="location"
				datatype="int"
				enumeration="<%=locations%>"
				title="Location"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="md5"
				property="md5"
				datatype="string"
				title="MD5"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="lastUpdate"
				property="lastUpdate"
				datatype="timestamp"
				title="Last update"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateTimeFormatter%>"
			/>
			<tbl:columndef 
				id="actions"
				title="Actions" 
				sortable="false" 
				filterable="false" 
				exportable="false"
			/>
			<tbl:columndef
				id="permissions"
				title="Permissions"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Formatter<Object> formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				Enumeration<String, String> annotationEnum = Base.getAnnotationTypeEnum(dc, at);
				%>
				<tbl:columndef 
					id="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+(loader.isSearchingInheritedAnnotations() ? " [I]" : " [A]")%>" 
					property="<%=(loader.isSearchingInheritedAnnotations() ? "##" : "#")+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1 && !loader.isSearchingInheritedAnnotations()%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar subclass="bottomborder">
					<tbl:button 
						id="btnNewDirectory"
						data-item-type="DIRECTORY"
						data-extra-url="<%="&parent_id="+directoryId%>"
						disabled="<%=!createDirectoryPermission%>" 
						image="directory_new.png" 
						title="New directory&hellip;" 
						visible="<%=!isSearch%>"
						tooltip="<%=createDirectoryPermission ? "Create a new directory" : "You do not have permission to create directories"%>" 
					/>
					<tbl:button 
						id="btnUpload"
						disabled="<%=!createFilePermission%>" 
						image="upload.png" 
						title="Upload file&hellip;" 
						visible="<%=!isSearch%>"
						tooltip="<%=createFilePermission ? "Upload a new file" : "You do not have permission to upload files"%>" 
					/>
					<tbl:button 
						id="btnNewURL"
						disabled="<%=!createFilePermission%>" 
						image="url_new.png" 
						title="New URL&hellip;" 
						visible="<%=!isSearch%>"
						tooltip="<%=createFilePermission ? "Create new URL reference" : "You do not have permission to create files"%>" 
					/>
					<tbl:button
						id="btnEditMultipleFiles"
						image="edit.png"
						title="Edit&hellip;"
						tooltip="Edit the selected files"
					/>
					<tbl:button 
						id="btnMoveFiles"
						subclass="auto-init"
						data-auto-init="menu-anchor"
						data-menu-id="moveFiles"
						image="move.png"
						title="Move&hellip;" 
						tooltip="Move the selected items"
						visible="<%=mode.hasToolbar()%>"
					/>
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
						visible="<%=mode.hasToolbar()%>"
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
						visible="<%=mode.hasToolbar()%>"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
						visible="<%=mode.hasToolbar()%>"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
						visible="<%=mode.hasToolbar()%>"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel visible="<%=!isSearch%>">
					<tbl:presetselector />
					<div style="padding-top: 4px;"><%=currentPath%></div>
				</tbl:panel>
				<tbl:panel visible="<%=isSearch%>">
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=numFiles + numDirectories%>" 
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="row-index bg-filled-100" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="row-index bg-filled-100">
								<div class="index-<%=mode.getName()%>">
									<div class="index"></div>
									<div class="check">
										<base:icon 
											subclass="link table-check"
											image="check_uncheck.png" 
											tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
											visible="<%=lastRow && mode.hasCheck()%>"
										/>
									</div>
									<div class="icons">
										<base:icon
											subclass="link table-filter-row-action"
											image="add.png"
											tooltip="Add extra filter row"
											visible="<%=lastRow%>"
										/><base:icon
											subclass="link table-filter-row-action"
											image="remove.png"
											tooltip="Remove this filter row"
											visible="<%=numRows > 1 || numFilters > 0 %>"
											data-remove-row="<%=filterNo%>"
										/>
									</div>
								</div>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
					<tbl:columnsubtitles />
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = 0;
					int selectedItemId = cc.getId();
					
					ItemContext dirContext = sc.getCurrentContext(Item.DIRECTORY, subcontext);
					if (directories != null)
					{
						while (directories.hasNext())
						{
							index++;
							numListed++;
							Directory item = directories.next();
							int itemId = item.getId();
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean uploadPermission = sc.hasPermission(Permission.CREATE, Item.FILE) && item.hasPermission(Permission.USE);
							String name = HTML.encodeTags(item.getName());
							String path = item.getPath().toString();
							String tagPath = HTML.encodeTags(path);
							String icon = item.getAutoCompress() ? "directory_compressed.png" : "directory.png";
							Directory parent = null;
							try
							{
								parent = item.getParent();
							}
							catch (Throwable t)
							{}
							String tooltip = mode.isSelectionMode() ?
								"Select this item" : "Edit this item";
							%>
							<tbl:row subclass="auto-init" data-auto-init="directory-row" data-directory-id="<%=itemId%>" data-directory-path="<%=tagPath%>" data-upload-permission="<%=uploadPermission?1:0%>">
								<tbl:header clazz="row-index bg-filled-100">
									<div class="index-<%=mode.getName()%>">
										<div class="index <%=index>999?"index-smaller":""%>"><base:icon 
											subclass="link auto-init"
											data-auto-init="open-directory"
											data-directory-id="<%=itemId %>"
											image="<%=icon%>" 
											tooltip="<%=tagPath%>"
										/></div>
										<div class="check">
											<base:input
												type="checkbox" 
												name="<%="D:"+itemId%>" 
												value="<%=itemId%>" 
												title="<%=name%>" 
												checked="<%=dirContext.getSelected().contains(itemId)%>"
												visible="<%=mode.hasCheck()%>"
											/>
										</div>
										<div class="icons">
											<base:icon 
												image="deleted.png"
												id="<%="delete."+itemId %>"
												subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
												data-item-type="DIRECTORY"
												data-item-id="<%=itemId%>"
												data-notify="reloadOnNotify"
												tooltip="This item has been scheduled for deletion" 
												visible="<%=item.isRemoved()%>"
											/><base:icon 
												image="shared.png" 
												id="<%="share."+itemId %>"
												subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
												data-item-type="DIRECTORY"
												data-item-id="<%=itemId%>"
												tooltip="This item is shared to other users, groups and/or projects" 
												visible="<%=item.isShared()%>"
											/>
										</div>
									</div>
								</tbl:header>
								<tbl:cell column="name"><div 
									class="link auto-init" 
									data-auto-init="directory-item"
									data-item-type="DIRECTORY"
									data-item-id="<%=itemId%>"
									data-force-edit="1"
									data-path="<%=tagPath %>"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="path" style="white-space: nowrap;">
									<%
									if (parent != null && mode.hasPropertyLink())
									{
										%>
										<div class="link auto-init"
											data-auto-init="open-directory"
											data-directory-id="<%=parent.getId() %>"
											title="Open this directory"><%=tagPath.substring(0, tagPath.length() - name.length())%></div>
										<%
									}
									else
									{
										%>
										<%=tagPath.substring(0, tagPath.length() - name.length())%>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="url">&nbsp;</tbl:cell>
								<tbl:cell column="fileServer">&nbsp;</tbl:cell>
								<tbl:cell column="size">&nbsp;</tbl:cell>
								<tbl:cell column="compressedSize">&nbsp;</tbl:cell>
								<tbl:cell column="compressed"><%=item.getAutoCompress() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="fileType">&nbsp;</tbl:cell>
								<tbl:cell column="mimeType">&nbsp;</tbl:cell>
								<tbl:cell column="characterSet">&nbsp;</tbl:cell>
								<tbl:cell column="md5">&nbsp;</tbl:cell>
								<tbl:cell column="location">&nbsp;</tbl:cell>
								<tbl:cell column="action">&nbsp;</tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="lastUpdate">&nbsp;</tbl:cell>
								<tbl:cell column="actions">&nbsp;</tbl:cell>
								<tbl:cell column="permissions"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										out.write(Base.getLinkedName(ID, sharees.next(), false, mode.hasEditLink()));
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
						<%
						}
					}
					if (files != null)
					{						
						while (files.hasNext())
						{
							File item = files.next();
							fileContext.setCurrentFile(item);
							int itemId = item.getId();
							Location location = item.getLocation();
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ?
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							String path = item.getPath().toString();
							String tagPath = HTML.encodeTags(path);
							String icon = "file.png";
							if (location == Location.EXTERNAL) 
							{
								icon = "url.png";
							}
							else if (item.isCompressed())
							{
								icon = "file_compressed.png";
							}
							String fileSize = Values.formatBytes(item.getSize(), 2);
							index++;
							numListed++;
							Directory parent = null;
							try
							{
								parent = item.getDirectory();
							}
							catch (Throwable t)
							{}
							%>
							<tbl:row>
								<tbl:header clazz="row-index bg-filled-100">
									<div class="index-<%=mode.getName()%>">
										<div class="index <%=index>999?"index-smaller":""%>"><base:icon 
											image="<%=icon%>" 
											tooltip="<%=tagPath%>"
										/></div>
										<div class="check">
											<base:input
												subclass="auto-init"
												data-auto-init="file-check"
												type="checkbox" 
												name="<%=itemId%>" 
												value="<%=itemId%>" 
												title="<%=tagPath%>"  
												checked="<%=cc.getSelected().contains(itemId) || selectedItemId == itemId%>"
												visible="<%=mode.hasCheck()%>"
											/>
											<base:input 
												subclass="auto-init"
												data-auto-init="file-check"
												type="radio" 
												name="item_id" 
												value="<%=itemId%>" 
												title="<%=tagPath%>"  
												checked="<%=selectedItemId == itemId%>"
												visible="<%=mode.hasRadio()%>"
											/>
										</div>
										<div class="icons">
											<base:icon 
												image="deleted.png"
												id="<%="delete."+itemId %>"
												subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												data-notify="reloadOnNotify"
												tooltip="This item has been scheduled for deletion" 
												visible="<%=item.isRemoved()%>"
											/><base:icon 
												image="shared.png" 
												id="<%="share."+itemId %>"
												subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												tooltip="This item is shared to other users, groups and/or projects" 
												visible="<%=item.isShared()%>"
											/>
										</div>
									</div>
								</tbl:header>
								<tbl:cell column="name"><div
									class="link auto-init"
									data-auto-init="file-item"
									data-item-id="<%=itemId%>"
									data-path="<%=tagPath %>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="path" style="white-space: nowrap;">
									<%
									if (parent != null && mode.hasPropertyLink())
									{
										%>
										<div class="link auto-init"
											data-auto-init="open-directory"
											data-directory-id="<%=parent.getId() %>"
											title="Open this directory"><%=tagPath.substring(0, tagPath.length() - name.length())%></div>
										<%
									}
									else
									{
										%>
										<%=tagPath.substring(0, tagPath.length() - name.length())%>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="url"><%=HTML.niceFormat(item.getUrl(), HTML.LINK_URL)%></tbl:cell>
								<tbl:cell column="fileServer"><base:propertyvalue 
										item="<%=item%>" 
										property="fileServer"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="size"><span title="<%=item.getSize()%> bytes"><%=fileSize%></span></tbl:cell>
								<tbl:cell column="compressedSize"><span title="<%=item.getCompressedSize()%> bytes"><%=Values.formatBytes(item.getCompressedSize(), 2)%></span></tbl:cell>
								<tbl:cell column="compressed"><%=item.isCompressed() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="writeProtected"><%=item.isWriteProtected() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="itemSubtype"
									><base:propertyvalue 
										item="<%=item%>" 
										property="itemSubtype"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="mimeType"><%=HTML.encodeTags(item.getMimeType())%></tbl:cell>
								<tbl:cell column="characterSet"><%=HTML.encodeTags(item.getCharacterSet())%></tbl:cell>
								<tbl:cell column="location"><%=item.getLocation()%></tbl:cell>
								<tbl:cell column="md5"><%=HTML.encodeTags(item.getMd5())%></tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="lastUpdate" value="<%=item.getLastUpdate()%>" />
								<tbl:cell column="actions"><%fileViewer.render();%></tbl:cell>
								<tbl:cell column="permissions"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<%
								if (item.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, item.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													bulletlist="<%=loader.useBulletList() %>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.hasProjectSpecificAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
						}
					}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50" visible="<%=!isSearch || hasFilter%>">
							<div class="messagecontainer note">
							No files or directories were found
							</div>
						</tbl:panel>
						<tbl:panel subclass="bg-filled-50" visible="<%=isSearch && !hasFilter%>">
							<div class="messagecontainer note">
							Please specify a search condition!
							</div>
						</tbl:panel>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
		</tbl:table>
	</div>
	<div id="reloadOnNotify"></div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (files != null) files.close();
	if (directories != null) directories.close();
	if (dc != null) dc.close();
}
%>
