<%-- $Id: list_designs.jsp 8180 2023-12-06 12:05:57Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.FileSet"
	import="net.sf.basedb.core.DataFileType"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.FeatureIdentificationMethod"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.AnnotationLoaderUtil"
	import="net.sf.basedb.core.snapshot.AnnotationTypeFilter"
	import="net.sf.basedb.core.snapshot.AnnotationSnapshot"
	import="net.sf.basedb.core.snapshot.AnnotationSetSnapshot"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.DataFileFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ButtonAction" 
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerContext"
	import="net.sf.basedb.clients.web.extensions.fileviewer.FileViewerUtil"
	import="net.sf.basedb.clients.web.util.ProjectSpecificInfoFilter"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Iterator"
	import="java.util.List"
	import="java.util.Map"
	import="java.util.Date"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ARRAYDESIGN;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
	private static final Enumeration<String, String> fiMethods = new Enumeration<String, String>();
	static
	{
		for (FeatureIdentificationMethod fim : FeatureIdentificationMethod.values())
		{
			fiMethods.add(Integer.toString(fim.getValue()), fim.toString());
		}
		fiMethods.lock();
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final String root = request.getContextPath()+"/";
final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("array design", "array designs");
final DbControl dc = sc.newDbControl(":List "+itemType);
ItemResultIterator<ArrayDesign> designs = null;
List<AnnotationLoaderUtil> annotationLoaders = new ArrayList<AnnotationLoaderUtil>();
try
{
	ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	SnapshotManager manager = new SnapshotManager();
	ProjectSpecificInfoFilter psInfo = new ProjectSpecificInfoFilter();
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at));
	}
	annotationTypeQuery = Base.getInheritedAnnotationColumns(cc.getSetting("columns"));
	for (AnnotationType at : annotationTypeQuery.list(dc))
	{
		annotationLoaders.add(new AnnotationLoaderUtil(dc, manager, at, false, true));
	}
	List<DataFileType> fileTypeColumns = new ArrayList<DataFileType>(Base.getDataFileColumns(itemType, null).list(dc));

	// Query for batches relatated to the current design
	final ItemQuery<ArrayBatch> batchQuery = ArrayBatch.getQuery();
	batchQuery.include(cc.getInclude());
	batchQuery.restrict(Restrictions.eq(Hql.property("arrayDesign"), Expressions.parameter("arrayDesign")));
	batchQuery.order(Orders.asc(Hql.property("name"))); 
	final boolean createBatchPermission = sc.hasPermission(Permission.CREATE, Item.ARRAYBATCH); 	

	// Get all platforms
	final ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(cc.getInclude());
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	Enumeration<String, String> platforms = new Enumeration<String, String>();
	for (Platform p : platformQuery.list(dc))
	{
		platforms.add(Integer.toString(p.getId()), p.getName());
	}
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, null);
	try
	{
		final ItemQuery<ArrayDesign> query = Base.getConfiguredQuery(dc, cc, jspContext, true, ArrayDesign.getQuery(), mode);
		designs = query.iterate(dc);
	}
	catch (Throwable t)
	{
		cc.setMessage(t.getMessage());
		t.printStackTrace();
	}
	Project activeProject = Project.getActive(dc);
	int numListed = 0;
	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	ExtensionsInvoker<ButtonAction> invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker<ListColumnAction<ArrayDesign,?>> columnsInvoker = ListColumnUtil.useExtensions(jspContext);
	FileViewerUtil fileViewer = FileViewerUtil.getOrCreate(jspContext, FileViewerContext.file());
	%>
	<base:page title="<%=title==null ? "Array designs" : title%>" type="<%=mode.getPageType()%>" id="list-page">
	<base:head scripts="table.js,~designs.js" styles="table.css,toolbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	
	<base:body>
		<h1><%=title==null ? "Array designs" : title%></h1>
		<div class="content">
		<tbl:table 
			id="designs" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			filterrows="<%=cc.getFilterRows()%>"
			subclass="fulltable"
			data-inherited-annotations="true"
			stickyheaders="<%=cc.getSetting("columns.sticky", "name")%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="entryDate"
				property="entryDate"
				datatype="date"
				title="Registered"
				sortable="true" 
				filterable="true"
				exportable="true"
				formatter="<%=dateFormatter%>"
			/>
			<tbl:columndef 
				id="hasFeatures"
				property="hasFeatures"
				datatype="boolean"
				title="Has features"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="numDbFeatures"
				property="numDbFeatures"
				datatype="int"
				title="Db features"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="numFileFeatures"
				property="numFileFeatures"
				datatype="int"
				title="File features"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="platform"
				property="platform"
				sortproperty="platform.name"
				exportproperty="platform.name:string"
				datatype="int"
				enumeration="<%=platforms%>"
				title="Platform"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="variant"
				property="variant.name"
				datatype="string"
				title="Variant"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>	
			<tbl:columndef 
				id="featureIdentificationMethod"
				property="featureIdentificationMethod"
				datatype="int"
				title="Feature ID meth."
				tooltip="Feature identification method"
				sortable="true" 
				filterable="true"
				exportable="true"
				enumeration="<%=fiMethods%>"
			/>	
			<tbl:columndef 
				id="numArrays"
				property="numArrays"
				datatype="int"
				title="Arrays/slide"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="plugin"
				property="job.pluginDefinition.name"
				datatype="string"
				title="Plugin"
				sortable="true"
				filterable="true"
				exportable="true"
				tooltip="The plug-in that was used to import features"
			/>
			<tbl:columndef 
				id="configuration"
				property="job.pluginConfiguration.name"
				datatype="string"
				title="Configuration"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The configuration/file format that was used to import features"
			/>
			<tbl:columndef 
				id="importdate"
				property="job.ended"
				datatype="date"
				title="Import date"
				sortable="true"
				filterable="true"
				exportable="true" 
				tooltip="The date and time of the feature import"
				formatter="<%=dateTimeFormatter%>"
			/>
			<tbl:columndef
				id="batches"
				title="Batches"
				property="&arrayBatches(name)"
				datatype="string"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="owner"
				property="owner.name"
				datatype="string"
				title="Owner"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>			
			<%
			for (AnnotationLoaderUtil loader : annotationLoaders)
			{
				AnnotationType at = loader.getAnnotationType();
				Formatter<Object> formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				Enumeration<String, String> annotationEnum = Base.getAnnotationTypeEnum(dc, at);
				%>
				<tbl:columndef 
					id="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+(loader.isSearchingInheritedAnnotations() ? " [I]" : " [A]")%>" 
					property="<%=(loader.isSearchingInheritedAnnotations() ? "##" : "#")+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					smartenum="<%=at.getDisplayAsList() %>"
					sortable="<%=at.getMultiplicity() == 1 && !loader.isSearchingInheritedAnnotations()%>" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			for (DataFileType ft : fileTypeColumns)
			{
				%>
				<tbl:columndef
					subclass="controlled-width"
					id="<%="ft"+ft.getId()%>"
					title="<%=HTML.encodeTags(ft.getName())+" [F]"%>"
					property="<%="¤" + ft.getId()+"(file.name)"%>"
					exportproperty="<%="¤" + ft.getId()+"(file.path)"%>"
					datatype="string"
					filterable="true"
					sortable="false"
					exportable="true"
					formatter="<%=new DataFileFormatter(dc, ft, mode, fileViewer) %>"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="permission"
				title="Permission"
			/>
			<tbl:columndef
				id="sharedTo"
				title="Shared to"
				filterable="true"
				filterproperty="!sharedTo.name"
				datatype="string"
			/>
			<tbl:columndef 
				id="xt-columns" 
				extensions="<%=columnsInvoker%>" 
				jspcontext="<%=jspContext%>" 
			/>
			<div class="panelgroup bg-filled-50 bottomborder">
				<tbl:toolbar
					subclass="bottomborder"
					visible="<%=mode.hasToolbar()%>"
					>
					<tbl:button 
						id="btnNewItem"
						disabled="<%=!createPermission%>" 
						image="new.png" 
						title="New&hellip;" 
						tooltip="<%=createPermission ? "Create new array design" : "You do not have permission to create array designs"%>" 
					/>
					<tbl:button 
						id="btnDeleteItems"
						image="delete.png"
						title="Delete" 
						tooltip="Delete the selected items" 
					/>
					<tbl:button 
						id="btnRestoreItems"
						image="restore.png"
						title="Restore" 
						tooltip="Restore the selected (deleted) items"
					/>
					<tbl:button 
						id="btnShareItems"
						image="share.png"
						title="Share&hellip;" 
						tooltip="Share the selected items"
					/>
					<tbl:button 
						id="btnSetOwner"
						image="take_ownership.png"
						title="Set owner&hellip;"
						tooltip="Change owner of the selected items"
					/>
					<tbl:button 
						id="btnColumns"
						image="columns.png" 
						title="Columns&hellip;" 
						tooltip="Show, hide and re-order columns" 
					/>
					<tbl:button
						id="btnInheritAnnotations"
						image="inherit.png"
						title="Inherit annotations&hellip;"
						tooltip="Batch inherit annotations from parent items"
					/>
					<tbl:button 
						id="btnImport"
						data-plugin-type="IMPORT"
						image="import.png" 
						title="Import&hellip;" 
						tooltip="Import data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
					/>
					<tbl:button 
						id="btnExport"
						data-plugin-type="EXPORT"
						image="export.png" 
						title="Export&hellip;" 
						tooltip="Export data" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
					/>
					<tbl:button 
						id="btnRunPlugin"
						data-plugin-type="OTHER"
						image="runplugin.png" 
						title="Run plugin&hellip;" 
						tooltip="Run a plugin" 
						visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
					/>
					<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
						wrapper="<%=new PrefixSuffixRenderer<ButtonAction>(jspContext, "<td>", "</td>") %>"/>
				</tbl:toolbar>
				<tbl:panel>
					<tbl:presetselector />
					<tbl:navigator
						page="<%=cc.getPage()%>" 
						rowsperpage="<%=cc.getRowsPerPage()%>" 
						totalrows="<%=designs == null ? 0 : designs.getTotalCount()%>" 
						visible="<%=mode.hasNavigator()%>"
					/>
				</tbl:panel>
			</div>
			<tbl:data>
				<tbl:headers>
					<tbl:headerrow>
						<tbl:header clazz="row-index bg-filled-100" />
						<tbl:columnheaders />
					</tbl:headerrow>
					<%
					int numFilters = cc.getNumPropertyFilters();
					int numRows = cc.getFilterRows();
					for (int filterNo = 0; filterNo < numRows; filterNo++)
					{
						boolean lastRow = filterNo == numRows-1;
						%>
						<tbl:headerrow>
							<tbl:header subclass="row-index bg-filled-100">
								<div class="index-<%=mode.getName()%>">
									<div class="index"></div>
									<div class="check">
										<base:icon 
											subclass="link table-check"
											image="check_uncheck.png" 
											tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
											visible="<%=lastRow && mode.hasCheck()%>"
										/>
									</div>
									<div class="icons">
										<base:icon
											subclass="link table-filter-row-action"
											image="add.png"
											tooltip="Add extra filter row"
											visible="<%=lastRow%>"
										/><base:icon
											subclass="link table-filter-row-action"
											image="remove.png"
											tooltip="Remove this filter row"
											visible="<%=numRows > 1 || numFilters > 0 %>"
											data-remove-row="<%=filterNo%>"
										/>
									</div>
								</div>
							</tbl:header>
							<tbl:propertyfilter row="<%=filterNo%>" />
						</tbl:headerrow>
						<%
					}
					%>
					<tbl:columnsubtitles />
				</tbl:headers>
				<tbl:rows>
					<%
					if (cc.getMessage() != null)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer error"><%=cc.getMessage()%></div>
						</tbl:panel>
						<%
						cc.setMessage(null);
					}
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (designs != null)
					{						
						while (designs.hasNext())
						{
							ArrayDesign item = designs.next();
							Job job = null;
							try
							{
								job = item.getJob();
							}
							catch (Throwable t)
							{}
							int itemId = item.getId();
							
							
							boolean deletePermission = item.hasPermission(Permission.DELETE);
							boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
							boolean usePermission = item.hasPermission(Permission.USE);
							boolean writePermission = item.hasPermission(Permission.WRITE);
							String tooltip = mode.isSelectionMode() ? 
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							String name = HTML.encodeTags(item.getName());
							index++;
							numListed++;
							%>
							<tbl:row>
								<tbl:header clazz="row-index bg-filled-100">
									<div class="index-<%=mode.getName()%>">
										<div class="index <%=index>999?"index-smaller":""%>"><%=index%></div>
										<div class="check">
											<base:input
												type="checkbox" 
												name="<%=itemId%>" 
												value="<%=itemId%>" 
												title="<%=name%>" 
												checked="<%=cc.getSelected().contains(itemId)%>"
												visible="<%=mode.hasCheck()%>"
											/>
											<base:input 
												type="radio" 
												name="item_id" 
												value="<%=itemId%>" 
												title="<%=name%>" 
												checked="<%=selectedItemId == itemId%>"
												visible="<%=mode.hasRadio()%>"
											/>
										</div>
										<div class="icons">
											<base:icon
												image="star.png"
												tooltip="This is a default item for the current project"
												visible="<%=activeProject != null && activeProject.isDefaultItem(item)%>" 
											/>
											<base:icon 
												image="deleted.png"
												id="<%="delete."+itemId %>"
												subclass="<%=deletePermission ? "table-delete-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												tooltip="This item has been scheduled for deletion" 
												visible="<%=item.isRemoved()%>"
											/><base:icon 
												image="shared.png" 
												id="<%="share."+itemId %>"
												subclass="<%=sharePermission ? "table-share-item" : "disabled" %>"
												data-item-id="<%=itemId%>"
												tooltip="This item is shared to other users, groups and/or projects" 
												visible="<%=item.isShared()%>"
											/>
										</div>
									</div>
								</tbl:header>
								<tbl:cell column="name"><div
									class="link table-item"
									data-item-id="<%=itemId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									tabindex="0"
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="entryDate" value="<%=item.getEntryDate()%>" />
								<tbl:cell column="platform"
									><base:propertyvalue 
										item="<%=item%>" 
										property="platform"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="variant"
									><base:propertyvalue 
										item="<%=item%>" 
										property="variant"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="hasFeatures"><%=item.hasFeatures() ? "yes" : "no"%></tbl:cell>
								<tbl:cell column="numDbFeatures"><%=item.getNumDbFeatures()%></tbl:cell>
								<tbl:cell column="numFileFeatures"><%=item.getNumFileFeatures()%></tbl:cell>
								<tbl:cell column="featureIdentificationMethod"><%=item.getFeatureIdentificationMethod()%></tbl:cell>
								<tbl:cell column="numArrays"><%=item.getNumArrays()%></tbl:cell>
								<tbl:cell column="plugin">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginDefinition" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
										/>
								</tbl:cell>
								<tbl:cell column="configuration">
									<base:propertyvalue 
										item="<%=item%>"
										property="job.pluginConfiguration" 
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/>
								</tbl:cell>
								<tbl:cell 
									column="importdate" 
									value="<%=job == null ? null : job.getEnded() %>" 
								/>
								<tbl:cell column="batches">
									<%
									batchQuery.setParameter("arrayDesign", itemId, Type.INT);
									try
									{
										String separator = "";
										for (ArrayBatch ab : batchQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, ab, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(ab.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
									<base:icon
										subclass="link auto-init"
										data-auto-init="new-batch"
										data-item-id="<%=itemId %>"
										image="add.png" 
										tooltip="Create new batch" 
										visible="<%=mode.hasEditLink() && createBatchPermission && usePermission %>"
									/>
								</tbl:cell>
								<tbl:cell column="owner"
									><base:propertyvalue 
										item="<%=item%>" 
										property="owner"
										enableEditLink="<%=mode.hasEditLink()%>" 
										enablePropertyLink="<%=mode.hasPropertyLink()%>"
									/></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>								
								<%
								if (item.hasFileSet())
								{
									FileSet fileSet = item.getFileSet();
									for (DataFileType ft : fileTypeColumns)
									{
										%>
										<tbl:cell column="<%="ft"+ft.getId()%>" value="<%=fileSet%>" />
										<%
									}
								}
								if (item.isAnnotated())
								{
									AnnotationSetSnapshot snapshot = manager.getSnapshot(dc, item.getAnnotationSet().getId());
									for (AnnotationLoaderUtil loader : annotationLoaders)
									{
										%>
										<tbl:cell 
											column="<%=(loader.isSearchingInheritedAnnotations() ? "ia" : "at")+loader.getId()%>"
											><%
											if (loader.find(snapshot, psInfo.reset())) 
											{
												%><tbl:cellvalue 
													list="<%=loader.getValues()%>"
													bulletlist="<%=loader.useBulletList() %>"
													suffix="<%=loader.getUnitSymbol()%>"
													clazz="<%=psInfo.hasProjectSpecificAnnotation() ? "ps-annotation" : null%>"
												/><%
											}
											%></tbl:cell>
										<%
									}
								}
								%>
								<tbl:cell column="permission"><%=PermissionUtil.getShortPermissions(item)%></tbl:cell>
								<tbl:cell column="sharedTo">
									<%
									Iterator<Nameable> sharees = ShareableUtil.getSharedTo(dc, item).iterator();
									while(sharees.hasNext())
									{
										Nameable n = sharees.next();
										if (mode.hasPropertyLink())
										{
											out.write(Base.getLinkedName(ID, n, false, mode.hasEditLink()));
										}
										else
										{
											out.write(HTML.encodeTags(n.getName()));
										}
										out.write(sharees.hasNext() ? ", " : "");
									}
									%>
								</tbl:cell>
								<tbl:xt-cells dc="<%=dc%>" item="<%=item%>">
									<tbl:cell column="xt-columns" />
								</tbl:xt-cells>
							</tbl:row>
							<%
							}
						}
					if (numListed == 0)
					{
						%>
						<tbl:panel subclass="bg-filled-50">
							<div class="messagecontainer note">
							<%=designs == null || designs.getTotalCount() == 0 ? "No array designs were found" : "No array designs on this page. Please select another page!" %>
							</div>
						</tbl:panel>
						<%
					}
					%>
				</tbl:rows>
			</tbl:data>
		</tbl:table>
		</div>
		
		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnOk" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button id="close" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button id="close" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (designs != null) designs.close();
	if (dc != null) dc.close();
}
%>
