<%-- $Id: edit_bioassay.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2006 Johan Enell, Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.PhysicalBioAssay"
	import="net.sf.basedb.core.BioMaterialEvent"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.ItemSubtype"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.Kit"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.ListUtil"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.tabcontrol.TabAction"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.json.JsonUtil"
	import="net.sf.basedb.util.json.NameableConverter"
	import="org.json.simple.JSONObject"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.PHYSICALBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl(":Edit "+itemType);
try
{
	String title = null;
	String name = null;
	PhysicalBioAssay pba = null;
	BioMaterialEvent creationEvent = null;
	Date eventDate = null;
	List<Extract> parentExtracts = null;
	
	boolean readCurrentSubtype = true;
	ItemSubtype currentSubtype = null;
	boolean readCurrentArraySlide = true;
	ArraySlide currentArraySlide = null;
	
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	
	boolean readCurrentHardware = true;
	Hardware currentHardware = null;
	
	boolean readCurrentKit = true;
	Kit currentKit = null;

	if (itemId == 0)
	{
		title = "Create physical bioassay";
		cc.removeObject("item");
		if (cc.getPropertyFilter("creationEvent.protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("creationEvent.protocol.name"));
		}
		if (cc.getPropertyFilter("creationEvent.hardware.name") != null)
		{
			currentHardware = Base.getFirstMatching(dc, Hardware.getQuery(), "name", cc.getPropertyFilter("creationEvent.hardware.name"));
		}
		if (cc.getPropertyFilter("creationEvent.kit.name") != null)
		{
			currentKit = Base.getFirstMatching(dc, Kit.getQuery(), "name", cc.getPropertyFilter("creationEvent.kit.name"));
		}
		if (cc.getPropertyFilter("arraySlide.name") != null)
		{
			currentArraySlide = Base.getFirstMatching(dc, ArraySlide.getQuery(), "name", cc.getPropertyFilter("arraySlide.name"));
		}
		name = Values.getString(cc.getPropertyValue("name"), "New physical bioassay");
		eventDate = cc.getPropertyObject("creationEvent.eventDate");
		
		int currentSubtypeId = Values.getInt(request.getParameter("subtype_id"));
		List<ItemSubtype> relatedToParent = Collections.emptyList();
		ItemQuery<Extract> extractsQuery = null;
		if (Values.getBoolean(request.getParameter("useParents")))
		{
			ItemContext lc = sc.getCurrentContext(Item.EXTRACT);
			if (lc.getSelected().size() > 0)
			{
				extractsQuery = Extract.getQuery();
				extractsQuery.include(Include.ALL);
				extractsQuery.order(Orders.asc(Hql.property("name")));
				extractsQuery.restrict(Restrictions.in(Hql.property("id"), 
					Expressions.parameter("selected", lc.getSelected(), Type.INT)));
			}
		}
		else if (request.getParameter("extract_id") != null)
		{
			int leId = Values.getInt(request.getParameter("extract_id"));
			extractsQuery = Extract.getQuery();
			extractsQuery.include(Include.ALL);
			extractsQuery.restrict(Restrictions.eq(Hql.property("id"), 
				Expressions.integer(leId)));
		}
		
		if (extractsQuery != null)
		{
			parentExtracts = extractsQuery.list(dc);
			if (currentSubtypeId == 0 && parentExtracts.size() > 0)
			{
				relatedToParent = ItemSubtype.getParentSubtypes(dc, parentExtracts.get(0), Item.PHYSICALBIOASSAY);
			}
		}
		
		if (currentSubtypeId == 0) 
		{
			if (relatedToParent.size() > 0)
			{
				// Find most recently used related subtype
				List<ItemSubtype> recentSubtypes = cc.getRecent(dc, Item.ITEMSUBTYPE);
				currentSubtype = ListUtil.findFirstCommon(recentSubtypes, relatedToParent, relatedToParent.get(0));
			}
			else
			{
				int recentSubtypeId = Values.getInt(cc.getRecent(Item.ITEMSUBTYPE.name(), 0));
				currentSubtypeId = Values.getInt(cc.getPropertyValue("itemSubtype"), recentSubtypeId);
				if (currentSubtypeId > 0) currentSubtype = ItemSubtype.getById(dc, currentSubtypeId);
			}
		}
	}
	else
	{
		pba = PhysicalBioAssay.getById(dc, itemId);
		pba.checkPermission(Permission.WRITE);
		creationEvent = pba.getCreationEvent();
		eventDate = creationEvent.getEventDate();
		cc.setObject("item", pba);
		title = "Edit physical bioassay -- " + HTML.encodeTags(pba.getName());
		name = pba.getName();
		
		try
		{
			currentSubtype = pba.getItemSubtype();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSubtype = false;
		}

		try
		{
			currentArraySlide = pba.getArraySlide();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArraySlide = false;
		}
		try
		{
			currentProtocol = creationEvent.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentHardware = creationEvent.getHardware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentHardware = false;
		}
		try
		{
			currentKit = creationEvent.getKit();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentKit = false;
		}
		
		// Query to retrieve source extracts
		ItemQuery<Extract> extractsQuery = creationEvent.getSources();
		extractsQuery.include(Include.ALL);
		extractsQuery.order(Orders.asc(Hql.property("srcevt", "position")));
		extractsQuery.order(Orders.asc(Hql.property("name")));
		parentExtracts = extractsQuery.list(dc);
		
	}
	
	// Default items 
	int activeProjectId = sc.getActiveProjectId();
	List<Protocol> defaultProtocols = null;
	List<Hardware> defaultHardware = null;
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		defaultProtocols = activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.PROTOCOL);
		defaultHardware = activeProject.findDefaultItemsOfRelatedSubtype(dc, currentSubtype, Item.HARDWARE);
	}
	
	// Load recently used items
	List<Protocol> recentProtocols = cc.getRecent(dc, Item.PROTOCOL, currentSubtype);
	List<Hardware> recentHardware = cc.getRecent(dc, Item.HARDWARE, currentSubtype);
	List<Kit> recentKits = cc.getRecent(dc, Item.KIT, currentSubtype);
	
	// Query to retrieve item types
	final ItemQuery<ItemSubtype> subtypesQuery = Base.getSubtypesQuery(itemType);
	subtypesQuery.include(Include.ALL);

	JSONObject jsonExtracts = new JSONObject();
	jsonExtracts.put("itemType", "EXTRACT");
	if (parentExtracts != null)
	{
		final BioMaterialEvent event = creationEvent;
		jsonExtracts.put("items", JsonUtil.toArray(parentExtracts, new NameableConverter<Extract>()
		{
			protected void setMore(JSONObject json, Extract e)
			{
				String value = ":1";
				String usedQuantity = null;
				if (event != null)
				{
					BioMaterialEventSource evtSrc = event.getEventSource(e);
					Float used = evtSrc.getUsedQuantity();
					usedQuantity = Values.formatNumber(used, -1);
					int position = evtSrc.getPosition();
					value = usedQuantity+":"+position;
				}
				json.put("name", e.getName() + (usedQuantity == null ? " [-]" : " [" +  usedQuantity + " µg]"));
				json.put("value", value);
			}
		}));
	}

	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	String dateFormat = FormatterSettings.getDateFormat(sc);
	String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	String htmlDateFormat = HTML.encodeTags(dateFormat);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), pba);
	ExtensionsInvoker<TabAction> invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,linkitems-2.js,subtypes.js,~bioassays.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>

		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioassay">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings"
			subclass="content dialogtabcontrol"
			position="bottom"  remember="<%=pba != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Physical bioassay" helpid="physicalbioassay.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=pba == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=name%>" 
					maxlength="<%=PhysicalBioAssay.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Type</th>
				<td>
					<select name="subtype_id" id="subtype_id"
						<%=!readCurrentSubtype ? "disabled readonly class=\"disabled selectionlist\"" : "class=\"selectionlist\""%>>
					<%
					if (!readCurrentSubtype)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						int currentSubtypeId = currentSubtype == null ? 0 : currentSubtype.getId();
						%>
						<option value="0">-none-
						<%
						for (ItemSubtype subtype : subtypesQuery.list(dc))
						{
							int id = subtype.getId();
							if (id != currentSubtypeId && subtype.isRemoved()) continue;
							%>
							<option value="<%=id == currentSubtypeId && pba != null ? -id : id%>" 
								<%=id == currentSubtypeId ? "selected" : ""%>
								title="<%=HTML.encodeTags(subtype.getDescription()) %>"
								><%=HTML.encodeTags(subtype.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Size</th>
				<td><input class="text required" type="text" name="size" id="size" style="width: 15em;"
					value="<%=pba == null ? Values.getString(cc.getPropertyValue("size"), "1") : pba.getSize()%>" 
					maxlength="10"></td>
				<td></td>
			</tr>
			<tr>
				<th>Created</th>
				<td>
					<table>
					<tr>
					<td>
						<input class="text" type="text" name="event_date" id="event_date" style="width: 15em;"
							value="<%=HTML.encodeTags(dateFormatter.format(eventDate))%>" 
							maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
					</td>
					<td>
						<base:calendar textarea="event_date" title="Created" />
					</td>
					</tr>
					</table>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Registered</th>
				<td><%=dateFormatter.format(creationEvent == null ? new Date() : creationEvent.getEntryDate())%></td>
				<td></td>
			</tr>
			<tr>
				<th>Protocol</th>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitems="<%=defaultProtocols%>"
						newitem="<%=pba == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Hardware</th>
				<td>
					<base:select 
						id="hardware_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentHardware%>"
						denied="<%=!readCurrentHardware%>"
						recent="<%=recentHardware%>"
						defaultitems="<%=defaultHardware%>"
						newitem="<%=pba == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Kit</th>
				<td>
					<base:select 
						id="kit_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentKit%>"
						denied="<%=!readCurrentKit%>"
						recent="<%=recentKits%>"
						newitem="<%=pba == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Array slide</th>
				<td>
					<base:select 
						id="arrayslide_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentArraySlide%>"
						denied="<%=!readCurrentArraySlide%>"
						newitem="<%=pba == null%>"
					/>
				</td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(pba == null ? cc.getPropertyValue("description") : pba.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			</table>
		</t:tab>
		
		<t:tab id="extracts" title="Extracts" helpid="physicalbioassay.extracts">
			<table class="fullform input100">
			<tr class="big">
				<th>Extracts</th>
				<td>
					<div class="selectionlist">
					<table>
					<tr>
					<td>
						<select name="extracts" id="extracts" 
							class="auto-init"
							data-auto-init="link-container"
							data-initial-items="[<%=HTML.encodeTags(jsonExtracts.toJSONString()) %>]"
							data-initial-action="<%=pba == null ? 1 : 0 %>"
							size="15" multiple>
						</select>
					</td>
					<td style="vertical-align: top;">
						<base:buttongroup vertical="true">
							<base:button 
								id="btnAddExtracts"
								subclass="leftaligned"
								style="width: 12em;"
								title="Add&nbsp;extracts&hellip;" 
								tooltip="Add extracts"
							/>
							<base:button 
								subclass="leftaligned auto-init"
								data-auto-init="remove-link"
								data-list-id="extracts"
								style="width: 12em;"
								title="Remove" 
								tooltip="Remove the selected extracts"
							/>
						</base:buttongroup>
					</td>
					</tr>
					</table>
					</div>
				</td>
			</tr>
			
			<tr>
				<th class="subprompt">used quantity</th>
				<td>
						<input class="text" type="text" name="used_quantity" id="used_quantity"
							style="width: 15em;" value="" maxlength="10"> (µg)
				</td>
			</tr>

			<tr>
				<th class="subprompt">position</th>
				<td>
						<input class="text" type="text" name="position" id="position"
							style="width: 15em;" maxlength="10"> (1 -- size of bioassay)
				</td>
			</tr>
			<tr class="dynamic">
				<th></th>
				<td></td>
			</tr>
			</table>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>
		
		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
