<%-- $Id: index.jsp 7954 2021-05-12 13:27:22Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.FeatureIdentificationMethod"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.DerivedBioAssay"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Path"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.OwnedItem"
	import="net.sf.basedb.core.AnnotatedItem"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.ItemAlreadyExistsException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.ProgressReporter"
	import="net.sf.basedb.core.IntegerParameterType"
	import="net.sf.basedb.core.FloatParameterType"
	import="net.sf.basedb.core.StringParameterType"
	import="net.sf.basedb.core.FileParameterType"
	import="net.sf.basedb.core.ItemParameterType"
	import="net.sf.basedb.core.BooleanParameterType"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.util.RemovableUtil"
	import="net.sf.basedb.util.ShareableUtil"
	import="net.sf.basedb.util.OwnableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.NameableFormatter"
	import="net.sf.basedb.util.formatter.FilePathFormatter"
	import="net.sf.basedb.clients.web.plugins.ItemQueryLoader"
	import="net.sf.basedb.clients.web.plugins.FileSetMemberLoader"
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveAction"
	import="net.sf.basedb.clients.web.extensions.edit.OnSaveRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnExportRenderer"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnAction"
	import="net.sf.basedb.clients.web.extensions.list.ListColumnUtil"
	import="java.util.Enumeration"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Arrays"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = Base.createDefaultContext("name", "name,platform,variant,hasData,description");
	private static final Item itemType = Item.RAWBIOASSAY;
	
	private static void registerExportUtils(ItemContext cc)
	{
		// Register formatters
		cc.setObject("export.formatter.&experiments(name)", new NameableFormatter());
		cc.setObject("export.formatter.&fileSet.members(file.name)", new FilePathFormatter());
		
		// Register dataloaders
		String rawParameter = "rawBioAssay";
		final ItemQuery<Experiment> experimentQuery = Experiment.getQuery();
		experimentQuery.include(cc.getInclude());
		experimentQuery.join(Hql.innerJoin("rawBioAssays", "rba"));
		experimentQuery.restrict(Restrictions.eq(Hql.alias("rba"), Expressions.parameter(rawParameter)));
		experimentQuery.order(Orders.asc(Hql.property("name"))); 
		cc.setObject("export.dataloader.&experiments(name)", new ItemQueryLoader<RawBioAssay>(experimentQuery, rawParameter));
		cc.setObject("export.dataloader.&fileSet.members(file.name)", new FileSetMemberLoader());
	}
	
	private static class UpdateArrayDesign
		implements Runnable
	{
		private final int jobId;
		private final int rawBioAssayId;
		private final int arrayDesignId;
		private final SessionControl sc;
		private final FeatureIdentificationMethod fiMethod;
		
		private UpdateArrayDesign(Job job, RawBioAssay rba, ArrayDesign design, FeatureIdentificationMethod fiMethod)
		{
			this.jobId = job.getId();
			this.rawBioAssayId = rba.getId();
			this.arrayDesignId = design.getId();
			this.sc = job.getSessionControl();
			this.fiMethod = fiMethod;
		}
		
		public void run()
		{
			DbControl dc = sc.newDbControl(":Update array design on raw bioassay");
			try
			{
				Job j = Job.getById(dc, jobId);
				j.start("Initialising...", Application.getHostName(), null);
				ProgressReporter progress = j.getProgressReporter(null);
				dc.commit();
				dc = sc.newDbControl(":Update array design on raw bioassay");
				RawBioAssay rba = RawBioAssay.getById(dc, rawBioAssayId);
				ArrayDesign design = ArrayDesign.getById(dc, arrayDesignId);
				try
				{
					rba.updateArrayDesign(design, fiMethod, progress);
					progress.display(99, "Committing changes to database...");
					dc.commit();
					dc = sc.newDbControl(":Update array design on raw bioassay");
					j = Job.getById(dc, jobId);
					j.doneOk("Array design updated successfully");
					j.setRemoved(true);
					dc.commit();
				}
				catch (Throwable t)
				{
					if (dc != null) dc.close();
					dc = sc.newDbControl(":Update array design on raw bioassay");
					j = Job.getById(dc, jobId);
					j.doneError(t.getMessage(), Arrays.asList(t));
					j.setRemoved(true);
					dc.commit();
				}
			}
			finally
			{
				if (dc != null) dc.close();
			}
		}
	}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final String mode = request.getParameter("mode");
final String callback = request.getParameter("callback");
final String itemId = request.getParameter("item_id");
final String listPage = "list_rawbioassays.jsp?ID="+ID
	+(mode == null ? "" : "&mode="+mode)
	+(callback == null ? "" : "&callback="+callback)
	+(itemId == null ? "" : "&item_id="+itemId);
final String viewPage = "view_rawbioassay.jsp?ID="+ID;
final String editPage = "edit_rawbioassay.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "List".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, defaultContext, true);
		redirect = listPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = listPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = listPage;
	}

	else if ("ViewItem".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = viewPage;
	}
	else if ("EditItem".equals(cmd))
	{
		// Display the edit page for a single item (should be opened in a popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		forward = editPage;
	}
	else if ("NewItem".equals(cmd))
	{
		// Display the edit page for a new item (should be opened in a popup)
		if (!sc.hasPermission(Permission.CREATE, itemType))
		{
			throw new PermissionDeniedException(Permission.CREATE, itemType.toString());
		}
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		cc.setId(0);
		forward = editPage;
	}
	else if ("UpdateItem".equals(cmd))
	{
		// Update the properties on an item (will close the popup)
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, defaultContext);
		final int maxRecent = Base.getMaxRecent(sc);
		dc = sc.newDbControl(":Edit "+itemType);
		RawBioAssay rba = cc.getObject("item");
		
		Platform platform = null;
		PlatformVariant variant = null;
		String pf = request.getParameter("platform");

		if (pf != null)
		{
			if (pf.startsWith("PLATFORM:"))
			{
				int platformId = Values.getInt(pf.substring(9), -1);
				if (platformId > 0) platform =  Platform.getById(dc, platformId);
			}
			else if (pf.startsWith("VARIANT:"))
			{
				int variantId = Values.getInt(pf.substring(8), -1);
				if (variantId > 0) 
				{
					variant = PlatformVariant.getById(dc, variantId);
					platform = variant.getPlatform();
				}
			}
		}
		RawDataType rdt = RawDataTypes.getRawDataType(Values.getStringOrNull(request.getParameter("rawdatatype")));
		cc.setRecent(Item.PLATFORM, platform, maxRecent);
		cc.setRecent(Item.PLATFORMVARIANT, variant, maxRecent);
		if (rdt != null) cc.setRecent("RawDataType", rdt.getId(), maxRecent);

		if (rba == null)
		{
			if (variant != null)
			{
				rba = RawBioAssay.getNew(dc, variant, rdt);
			}
			else
			{
				rba = RawBioAssay.getNew(dc, platform, rdt);
			}
			message = "Raw bioassay created";
			dc.saveItem(rba);
		}
		else
		{
			dc.reattachItem(rba, false);
			if (variant != null)
			{
				rba.setVariant(variant, rdt);
			}
			else if (platform != null)
			{
				rba.setPlatform(platform, rdt);
			}
			message = "Raw bioassay updated";
		}
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(Item.RAWBIOASSAY), rba);
		ExtensionsInvoker<OnSaveAction> invoker = EditUtil.useOnSaveExtensions(jspContext);
		try
		{
			rba.setName(Values.getStringOrNull(request.getParameter("name")));
			rba.setDescription(Values.getStringOrNull(request.getParameter("description")));
			int protocolId = Values.getInt(request.getParameter("protocol_id"), -1);
			if (protocolId >= 0)  // < 0 = denied or unchanged
			{
				Protocol pt = protocolId == 0 ? null : Protocol.getById(dc, protocolId);
				rba.setProtocol(pt);
				cc.setRecent(Item.PROTOCOL, pt, maxRecent);
			}
			int softwareId = Values.getInt(request.getParameter("software_id"), -1);
			if (softwareId >= 0) // < 0 = denied or unchanged
			{
				Software sw = softwareId == 0 ? null : Software.getById(dc, softwareId);
				rba.setSoftware(sw);
				cc.setRecent(Item.SOFTWARE, sw, maxRecent);
			}
			int bioAssayId = Values.getInt(request.getParameter("bioassay_id"), -1);
			if (bioAssayId >= 0) // < 0 = denied or unchanged
			{
				DerivedBioAssay bioAssay = bioAssayId == 0 ? null : DerivedBioAssay.getById(dc, bioAssayId);
				rba.setParentBioAssay(bioAssay);
				cc.setRecent(Item.DERIVEDBIOASSAY, bioAssay, maxRecent);
			}
			int extractId = Values.getInt(request.getParameter("extract_id"), -1);
			if (extractId >= 0) // < 0 = denied or unchanged
			{
				Extract extract = extractId == 0 ? null : Extract.getById(dc, extractId);
				rba.setParentExtract(extract);
				cc.setRecent(Item.EXTRACT, extract, maxRecent);
			}

			Job job = null;
			ArrayDesign ad = null;
			FeatureIdentificationMethod fiMethod = null;
			int arrayDesignId = Values.getInt(request.getParameter("arraydesign_id"), -1);
			if (arrayDesignId >= 0) // < 0 = denied or unchanged
			{
				ad = arrayDesignId == 0 ? null : ArrayDesign.getById(dc, arrayDesignId);
				if (!rba.isSameArrayDesign(ad) || !rba.isInDatabase())
				{
					if (rba.hasData())
					{
						try
						{
							fiMethod = FeatureIdentificationMethod.valueOf(request.getParameter("fiMethod"));
						}
						catch (Exception ex)
						{}
						if (rba.getRawDataType().isStoredInDb() && ad != null && ad.hasFeatures())
						{
							// Create job and assign it to another thread
							job = Job.getNew(dc, null, null, null);
							job.setName("Validating array design on " + rba.getName());
							job.setPrepared(Application.getHostName(), null);
							job.setSendMessage(Values.getBoolean(sc.getUserClientSetting("plugins.sendmessage"), false));
							dc.saveItem(job);
						}
						else
						{
							rba.updateArrayDesign(ad, fiMethod, null);
						}
					}
					else
					{
						rba.setArrayDesign(ad);
					}
				}
				cc.setRecent(Item.ARRAYDESIGN, ad, maxRecent);
			}
	
			// Data files tab
			boolean validate = Values.getBoolean(request.getParameter("datafiles.validate"));
			Base.updateFiles(dc, rba, request, validate, cc, maxRecent);
			
			// Annotations tab
			Base.updateAnnotations(dc, rba, rba, request);
			
			// OnSave extensions
			invoker.render(OnSaveRenderer.ON_SAVE);
			dc.commit();
			invoker.render(OnSaveRenderer.ON_COMMIT);
			if (job != null) 
			{
				redirect = "../jobs/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+job.getId();
				Thread updateThread = new Thread(new UpdateArrayDesign(job, rba, ad, fiMethod));
				updateThread.setPriority(Thread.currentThread().getPriority() - 1);
				updateThread.start();
			}
		}
		catch (Exception ex)
		{
			invoker.render(OnSaveRenderer.onRollback(ex));
			throw ex;
		}
		finally
		{
			cc.removeObject("item");
		}
	}
	else if ("DeleteItem".equals(cmd))
	{
		// Delete a single item and then return to the view page
		dc = sc.newDbControl(":Delete "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), true);
		dc.commit();
		redirect = viewPage;
	}
	else if ("DeleteItems".equals(cmd))
	{
		// Delete all selected items on the list page
		dc = sc.newDbControl(":Delete "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), true);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be deleted, because you have no DELETE permission";
		}
		redirect = listPage;
	}
	else if ("RestoreItem".equals(cmd))
	{
		// Restore a single item and then return to the view page
		dc = sc.newDbControl(":Restore "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		RemovableUtil.setRemoved(dc, itemType, Collections.singleton(cc.getId()), false);
		dc.commit();
		redirect = viewPage;
	}
	else if ("RestoreItems".equals(cmd))
	{
		// Restore all selected items on the list page
		dc = sc.newDbControl(":Restore "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		int numTotal = cc.getSelected().size();
		int numRemoved = RemovableUtil.setRemoved(dc, itemType, cc.getSelected(), false);
		dc.commit();
		if (numTotal != numRemoved)
		{
			message = (numRemoved == 0 ? "No" : "Only "+numRemoved+" of "+numTotal) + " items could be restored, because you have no WRITE permission";
		}
		redirect = listPage;
	}
	else if ("ShareItem".equals(cmd))
	{
		// Display a popup window for sharing a single item
		dc = sc.newDbControl(":Share "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, Collections.singleton(cc.getId()));
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ShareItems".equals(cmd))
	{
		// Display a popup window for sharing all selected items on the list page
		dc = sc.newDbControl(":Share "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		MultiPermissions permissions = ShareableUtil.getMultiPermissions(dc, itemType, cc.getSelected());
		dc.close();
		cc.setObject("MultiPermissions", permissions);
		redirect = "../../common/share/share.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItem".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl(":Set owner of "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		OwnedItem item = (OwnedItem)itemType.getById(dc, cc.getId());
		cc.setObject("OwnedItems", Collections.singleton(item));
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("SetOwnerOfItems".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl(":Set owner of "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<OwnedItem> items = new HashSet<OwnedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((OwnedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("OwnedItems", items);
		redirect = "../../common/ownership/ownership.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("InheritAnnotations".equals(cmd))
	{
		// Change owner of items selected on a list page
		dc = sc.newDbControl(":Inherit annotations "+itemType);
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		Set<AnnotatedItem> items = new HashSet<AnnotatedItem>();
		for (Integer id : cc.getSelected())
		{
			if (id != null) items.add((AnnotatedItem)itemType.getById(dc, id));
		}
		dc.close();
		cc.setObject("AnnotatedItems", items);
		redirect = "../../common/annotations/batch_inherit.jsp?ID="+ID+"&item_type="+itemType.name();
	}
	else if ("ExportItems".equals(cmd))
	{
		// Run an export plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		dc = sc.newDbControl(":Export "+itemType);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		cc.setQuery(query);
		cc.configureQuery(dc, query, jspContext, true);
		registerExportUtils(cc);
		ExtensionsInvoker<ListColumnAction<RawBioAssay,?>> listInvoker = ListColumnUtil.useExtensions(jspContext);
		listInvoker.render(new ListColumnExportRenderer<RawBioAssay>(cc));
		dc.close();
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Export+raw+bioassays";
	}
	else if ("ExportItem".equals(cmd))
	{
		// Run an export plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		registerExportUtils(cc);
		redirect = "../../common/export/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Export+raw+bioassay";
	}
	else if ("ImportItems".equals(cmd))
	{
		// Run an import plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		dc = sc.newDbControl(":Import "+itemType);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		cc.configureQuery(dc, query, jspContext, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&title=Import+raw+bioassays";
	}
	else if ("ImportItem".equals(cmd))
	{
		// Run an import plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/import/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&title=Import+raw+bioassay";
	}
	else if ("RunListPlugin".equals(cmd))
	{
		// Run another plugin in a list context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		dc = sc.newDbControl(":Run plugin "+itemType);
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		cc.configureQuery(dc, query, jspContext, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=LIST&main_type=OTHER&title=Run+plugin";
	}
	else if ("RunPlugin".equals(cmd))
	{
		// Run another plugin in single-item context
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../../common/plugin/index.jsp?ID="+ID+"&cmd=SelectPlugin&item_type="+itemType.name()+"&context_type=ITEM&main_type=OTHER&title=Run+plugin";
	}
	else if ("NewExperiment".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		redirect = "../experiments/index.jsp?ID="+ID+"&cmd=NewItem&rawbioassays=1";
	}
	else if ("CreateItemList".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		dc = sc.newDbControl(":Create "+itemType+" item list");
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		cc.configureQuery(dc, query, jspContext, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../views/itemlists/index.jsp?ID="+ID+"&cmd=NewItem&addItems=1&memberType=RAWBIOASSAY&formId=rawbioassays";
	}
	else if ("AddItemsToList".equals(cmd))
	{
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, pageContext, defaultContext);
		final ItemQuery<RawBioAssay> query = RawBioAssay.getQuery();
		dc = sc.newDbControl(":Add items to "+itemType+" item list");
		JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.list(itemType), null);
		cc.configureQuery(dc, query, jspContext, true);
		dc.close();
		cc.setQuery(query);
		redirect = "../../views/itemlists/add_items.jsp?ID="+ID+"&memberType=RAWBIOASSAY&formId=rawbioassays";
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}

}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	sc.setSessionSetting("alert-message", message);
	pageContext.forward(forward);
}
else if (redirect != null)
{
	sc.setSessionSetting("alert-message", message);
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

